ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.15 by root, Fri Dec 10 21:15:06 2010 UTC vs.
Revision 1.75 by root, Tue Aug 1 03:48:59 2023 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in (or to replace in your .staticperlrc)
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9DLCACHE=
10 10
11# perl build variables 11# perl build variables
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12MAKE=make
13PERL_VERSION=http://stableperl.schmorp.de/dist/latest.tar.gz # 5.12.5 and 5.8.9 are good choices for small builds
14PERL_CC=cc
13PERL_CONFIGURE="" # additional Configure arguments 15PERL_CONFIGURE="" # additional Configure arguments
14PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 16PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
15PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 17PERL_OPTIMIZE="-Os" # -Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
16 18
17ARCH="$(uname -m)" 19ARCH="$(uname -m)"
18 20
19case "$ARCH" in 21#case "$ARCH" in
20 i*86 | x86_64 | amd64 ) 22# i*86 | x86_64 | amd64 )
21 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 23# PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
22 case "$ARCH" in 24# case "$ARCH" in
23 i*86 ) 25# i*86 )
24 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 26# PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
25 ;; 27# ;;
26 esac 28# esac
27 ;; 29# ;;
28esac 30#esac
29 31
30# -Wl,--gc-sections makes it impossible to check for undefined references 32# -Wl,--gc-sections makes it impossible to check for undefined references
31# for some reason so we need to patch away the "-no" after Configure and before make :/ 33# for some reason so we need to patch away the "-no" after Configure and before make :/
32# -z muldefs is to work around uclibc's pthread static linking bug 34# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
33PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 35#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LDFLAGS=
34PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 37PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
35 38
36# some configuration options for modules 39# some configuration options for modules
37export PERL_MM_USE_DEFAULT=1 40PERL_MM_USE_DEFAULT=1
41PERL_MM_OPT="MAN1PODS= MAN3PODS="
38#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 42#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
39export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 43#EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
44export PERL_MM_USE_DEFAULT PERL_MM_OPT
40 45
41# which extra modules to install by default from CPAN that are 46# which extra modules to install by default from CPAN that are
42# required by mkbundle 47# required by mkbundle
43STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 48STATICPERL_MODULES="ExtUtils::MakeMaker ExtUtils::CBuilder common::sense Pod::Strip PPI PPI::XS Pod::Usage"
44 49
45# which extra modules you might want to install 50# which extra modules you might want to install
46EXTRA_MODULES="" 51EXTRA_MODULES=""
47 52
48# overridable functions 53# overridable functions
49preconfigure() { : ; } 54preconfigure() { : ; }
55patchconfig() { : ; }
50postconfigure() { : ; } 56postconfigure() { : ; }
51postbuild() { : ; } 57postbuild() { : ; }
58postcpanconfig() { : ; }
52postinstall() { : ; } 59postinstall() { : ; }
53 60
54# now source user config, if any 61# now source user config, if any
55if [ "$STATICPERLRC" ]; then 62if [ "$STATICPERLRC" ]; then
56 . "$STATICPERLRC" 63 . "$STATICPERLRC"
57else 64else
61fi 68fi
62 69
63############################################################################# 70#############################################################################
64# support 71# support
65 72
66MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}" 73# work around ExtUtils::CBuilder and others
74export CC="$PERL_CC"
75export CFLAGS="$PERL_CFLAGS"
76export LD="$PERL_CC"
77export LDFLAGS="$PERL_LDFLAGS"
78unset LIBS
79
67PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 80PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
68 81
69unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 82unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
83unset PERL_MB_OPT
70export LC_ALL=C # just to be on the safe side 84LC_ALL=C; export LC_ALL # just to be on the safe side
85
86# prepend PATH - not required by staticperl itself, but might make
87# life easier when working in e.g. "staticperl cpan / look"
88PATH="$PERL_PREFIX/perl/bin:$PATH"
71 89
72# set version in a way that Makefile.PL can extract 90# set version in a way that Makefile.PL can extract
73VERSION=VERSION; eval \ 91VERSION=VERSION; eval \
74$VERSION=0.91 92$VERSION="1.46"
75
76BZ2=bz2
77BZIP2=bzip2
78 93
79fatal() { 94fatal() {
80 printf -- "\nFATAL: %s\n\n" "$*" >&2 95 printf -- "\nFATAL: %s\n\n" "$*" >&2
81 exit 1 96 exit 1
82} 97}
122 137
123############################################################################# 138#############################################################################
124# download/configure/compile/install perl 139# download/configure/compile/install perl
125 140
126clean() { 141clean() {
127 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 142 rm -rf "$STATICPERL/src"
143}
144
145realclean() {
146 rm -f "$PERL_PREFIX/staticstamp.postinstall"
147 rm -f "$PERL_PREFIX/staticstamp.install"
148 rm -f "$STATICPERL/src/perl/staticstamp.configure"
128} 149}
129 150
130fetch() { 151fetch() {
152(
131 rcd "$STATICPERL" 153 rcd "$STATICPERL"
132 154
133 mkdir -p src 155 mkdir -p src
134 rcd src 156 rcd src
135 157
136 if ! [ -d "perl-$PERL_VERSION" ]; then 158 if ! [ -d "perl" ]; then
137 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then 159 rm -rf unpack
160 mkdir -p unpack
138 161
162 case "$PERL_VERSION" in
163 *:* )
164 # url
165 PERLURL="$PERL_VERSION"
166 PERLTAR="$(basename "$PERL_VERSION")"
167 ;;
168 /* )
169 # directory
170 verbose "copying $PERL_VERSION"
171 cp -Rp "$PERL_VERSION/." unpack/.
172 chmod -R u+w unpack
173 mv unpack perl
174 return
175 ;;
176 * )
139 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2" 177 PERLURL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.bz2"
178 PERLTAR=perl-$PERL_VERSION.tar.bz2
179 ;;
180 esac
140 181
182 if ! [ -e "$PERLTAR" ]; then
141 verblock <<EOF 183 verblock <<EOF
142downloading perl 184downloading perl
185
186trying to download from $PERLURL
187
188you can configure a download cache directory via DLCACHE
189in your .staticperlrc to avoid repeated downloads.
190
143to manually download perl yourself, place 191to manually download perl yourself, place a suitable tarball in
144perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 192$DLCACHE/$PERLTAR
145trying $URL
146EOF
147 193
194either curl or wget is required for automatic download.
195curl is tried first, then wget.
196EOF
197
148 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 198 rm -f $PERLTAR~ # just to be on the safe side
149 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 199 { [ "$DLCACHE" ] && cp "$DLCACHE"/$PERLTAR $PERLTAR~ >/dev/null 2>&1; } \
150 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 200 || wget -O $PERLTAR~ "$PERLURL" \
201 || curl -f >$PERLTAR~ "$PERLURL" \
151 || fatal "$URL: unable to download" 202 || fatal "$URL: unable to download"
152 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 203 rm -f $PERLTAR
204 mv $PERLTAR~ $PERLTAR
205 if [ "$DLCACHE" ]; then
206 mkdir -p "$DLCACHE"
207 cp $PERLTAR "$DLCACHE"/$PERLTAR~$$~ && \
208 mv "$DLCACHE"/$PERLTAR~$$~ "$DLCACHE"/$PERLTAR
209 fi
153 fi 210 fi
154 211
155 verblock <<EOF 212 verblock <<EOF
156unpacking perl 213unpacking perl
157EOF 214EOF
158 215
159 mkdir -p unpack 216 case "$PERLTAR" in
160 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 217 *.xz ) UNCOMPRESS="xz -d" ;;
218 *.lzma ) UNCOMPRESS="lzma -d" ;;
219 *.bz2 ) UNCOMPRESS="bzip2 -d" ;;
220 *.gz ) UNCOMPRESS="gzip -d" ;;
221 *.tar ) UNCOMPRESS="cat" ;;
222 * )
223 fatal "don't know hot to uncompress $PERLTAR,\nonly tar, tar.gz, tar.bz2, tar.lzma and tar.xz are supported."
224 exit 1
225 ;;
226 esac
227
228 <"$PERLTAR" $UNCOMPRESS -d | ( cd unpack && tar xf - ) \
161 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 229 || fatal "$PERLTAR: error during unpacking"
162 chmod -R u+w unpack/perl-$PERL_VERSION 230
163 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 231 if [ -d unpack/*/ ]; then
232 chmod -R u+w unpack/*/
233 mv unpack/*/ perl
164 rmdir -p unpack 234 rmdir -p unpack
235 else
236 fatal "unpacking $PERLTAR did not result in a single directory, don't know how to handle this"
237 fi
238
239 rm "$PERLTAR"
165 fi 240 fi
241) || exit
166} 242}
167 243
168# similar to GNU-sed -i or perl -pi 244# similar to GNU-sed -i or perl -pi
169sedreplace() { 245sedreplace() {
170 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 246 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
247 rm -f "$2"
171 mv "$2~" "$2" 248 mv "$2~" "$2"
172} 249}
173 250
251configure_failure() {
252 cat <<EOF
253
254
255***
256*** Configure failed - see above for the exact error message(s).
257***
258*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
259*** flags are not supported by your compiler. Less often, this is because
260*** PERL_LIBS either contains a library not available on your system (such as
261*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
262***
263*** You can provide your own flags by creating a ~/.staticperlrc file with
264*** variable assignments. For example (these are the actual values used):
265***
266
267PERL_CC="$PERL_CC"
268PERL_CCFLAGS="$PERL_CCFLAGS"
269PERL_OPTIMIZE="$PERL_OPTIMIZE"
270PERL_LDFLAGS="$PERL_LDFLAGS"
271PERL_LIBS="$PERL_LIBS"
272
273EOF
274 exit 1
275}
276
174configure() { 277configure() {
278(
175 fetch 279 fetch
176 280
177 rcd "$STATICPERL/src/perl-$PERL_VERSION" 281 rcd "$STATICPERL/src/perl"
178 282
179 [ -e staticstamp.configure ] && return 283 [ -e staticstamp.configure ] && return
180 284
181 verblock <<EOF 285 verblock <<EOF
182configuring $STATICPERL/src/perl-$PERL_VERSION 286configuring $STATICPERL/src/perl
183EOF 287EOF
184 288
185 rm -f "$PERL_PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
186 290
187 make distclean >/dev/null 2>&1 291 "$MAKE" distclean >/dev/null 2>&1
188 292
293 sedreplace '/^#define SITELIB/d' config_h.SH
294
189 # I hate them 295 # I hate them for this
190 grep -q -- -fstack-protector Configure && \ 296 grep -q -- -fstack-protector Configure && \
191 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 297 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
192 298
193 preconfigure 299 # what did that bloke think
300 grep -q -- usedl=.define hints/darwin.sh && \
301 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
302
303 preconfigure || fatal "preconfigure hook failed"
194 304
195# trace configure \ 305# trace configure \
196 sh Configure -Duselargefiles \ 306 sh Configure -Duselargefiles \
197 -Uuse64bitint \ 307 -Uuse64bitint \
198 -Dusemymalloc=n \ 308 -Dusemymalloc=n \
199 -Uusedl \ 309 -Uusedl \
200 -Uusethreads \ 310 -Uusethreads \
201 -Uuseithreads \ 311 -Uuseithreads \
202 -Uusemultiplicity \ 312 -Uusemultiplicity \
203 -Duseperlio \
204 -Uusesfio \ 313 -Uusesfio \
205 -Uuseshrplib \ 314 -Uuseshrplib \
315 -Uinstallusrbinperl \
206 -Dcppflags="$PERL_CPPFLAGS" \ 316 -A ccflags=" $PERL_CCFLAGS" \
207 -Dccflags="-g2 -fno-strict-aliasing" \ 317 -Dcc="$PERL_CC" \
208 -Doptimize="$PERL_OPTIMIZE" \ 318 -Doptimize="$PERL_OPTIMIZE" \
209 -Dldflags="$PERL_LDFLAGS" \ 319 -Dldflags="$PERL_LDFLAGS" \
210 -Dlibs="$PERL_LIBS" \ 320 -Dlibs="$PERL_LIBS" \
211 -Dprefix="$PERL_PREFIX" \ 321 -Dprefix="$PERL_PREFIX" \
212 -Dbin="$PERL_PREFIX/bin" \ 322 -Dbin="$PERL_PREFIX/bin" \
213 -Dprivlib="$PERL_PREFIX/lib" \ 323 -Dprivlib="$PERL_PREFIX/lib" \
214 -Darchlib="$PERL_PREFIX/lib" \ 324 -Darchlib="$PERL_PREFIX/lib" \
215 -Uusevendorprefix \ 325 -Uusevendorprefix \
216 -Dsitelib="$PERL_PREFIX/lib" \ 326 -Dsitelib="$PERL_PREFIX/lib" \
217 -Dsitearch="$PERL_PREFIX/lib" \ 327 -Dsitearch="$PERL_PREFIX/lib" \
218 -Usitelibexp \
219 -Uman1dir \ 328 -Uman1dir \
220 -Uman3dir \ 329 -Uman3dir \
221 -Usiteman1dir \ 330 -Usiteman1dir \
222 -Usiteman3dir \ 331 -Usiteman3dir \
223 -Dpager=/usr/bin/less \ 332 -Dpager=/usr/bin/less \
224 -Demail="$EMAIL" \ 333 -Demail="$EMAIL" \
225 -Dcf_email="$EMAIL" \ 334 -Dcf_email="$EMAIL" \
226 -Dcf_by="$EMAIL" \ 335 -Dcf_by="$EMAIL" \
227 $PERL_CONFIGURE \ 336 $PERL_CONFIGURE \
337 -Duseperlio \
338 -Uversiononly \
228 -dE || fatal "Configure failed" 339 -dE || configure_failure
229 340
230 sedreplace ' 341 sedreplace '
231 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 342 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
232 s/ *-fno-stack-protector */ /g 343 s/ *-fno-stack-protector */ /g
233 ' config.sh 344 ' config.sh
234 345
346 patchconfig || fatal "patchconfig hook failed"
347
235 sh Configure -S || fatal "Configure -S failed" 348 sh Configure -S || fatal "Configure -S failed"
236 349
237 postconfigure || fatal "postconfigure hook failed" 350 postconfigure || fatal "postconfigure hook failed"
238 351
239 touch staticstamp.configure 352 : > staticstamp.configure
353) || exit
354}
355
356write_shellscript() {
357 {
358 echo "#!/bin/sh"
359 echo "STATICPERL=\"$STATICPERL\""
360 echo "PERL_PREFIX=\"$PERL_PREFIX\""
361 echo "MAKE=\"$MAKE\""
362 cat
363 } >"$PERL_PREFIX/bin/$1"
364 chmod 755 "$PERL_PREFIX/bin/$1"
240} 365}
241 366
242build() { 367build() {
368(
243 configure 369 configure
244 370
245 rcd "$STATICPERL/src/perl-$PERL_VERSION" 371 rcd "$STATICPERL/src/perl"
246 372
247 verblock <<EOF 373 verblock <<EOF
248building $STATICPERL/src/perl-$PERL_VERSION 374building $STATICPERL/src/perl
249EOF 375EOF
250 376
251 rm -f "$PERL_PREFIX/staticstamp.install" 377 rm -f "$PERL_PREFIX/staticstamp.install"
252 378
253 make || fatal "make: error while building perl" 379 "$MAKE" || fatal "make: error while building perl"
254 380
255 postbuild || fatal "postbuild hook failed" 381 postbuild || fatal "postbuild hook failed"
382) || exit
383}
384
385_postinstall() {
386 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
387 NOCHECK_INSTALL=+
388 instcpan $STATICPERL_MODULES
389 [ "$EXTRA_MODULES" ] && instcpan $EXTRA_MODULES
390
391 postinstall || fatal "postinstall hook failed"
392
393 : > "$PERL_PREFIX/staticstamp.postinstall"
394 fi
256} 395}
257 396
258install() { 397install() {
398(
259 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then 399 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
260 build 400 build
261 401
262 verblock <<EOF 402 verblock <<EOF
263installing $STATICPERL/src/perl-$PERL_VERSION 403installing $STATICPERL/src/perl
264to $PERL_PREFIX 404to $PERL_PREFIX
265EOF 405EOF
266 406
267 ln -sf "perl/bin/" "$STATICPERL/bin" 407 ln -sf "perl/bin/" "$STATICPERL/bin"
268 ln -sf "perl/lib/" "$STATICPERL/lib" 408 ln -sf "perl/lib/" "$STATICPERL/lib"
269 409
410 mkdir "$STATICPERL/patched"
411
270 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 412 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
271 rm -rf "$PERL_PREFIX" # by this rm -rf 413 rm -rf "$PERL_PREFIX" # by this rm -rf
272 414
415 rcd "$STATICPERL/src/perl"
416
273 make install || fatal "make install: error while installing" 417 "$MAKE" install || fatal "make install: error while installing"
274 418
275 rcd "$PERL_PREFIX" 419 rcd "$PERL_PREFIX"
276 420
277 # create a "make install" replacement for CPAN 421 # create a "make install" replacement for CPAN
278 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 422 write_shellscript SP-make-make <<'end_of_make'
279make || exit 423#CAT make-make.sh
424end_of_make
280 425
281if find blib/arch/auto -type f | grep -q -v .exists; then 426 # create a "make install" replacement for CPAN
282 echo Probably an XS module, rebuilding perl 427 write_shellscript SP-make-install-make <<'end_of_make_install_make'
283 if make perl; then 428#CAT make-install-make.sh
284 mv perl "$PERL_PREFIX"/bin/perl 429end_of_make_install_make
285 make -f Makefile.aperl map_clean
286 else
287 make -f Makefile.aperl map_clean
288 exit 1
289 fi
290fi
291 430
292make install UNINST=1 431 # create a "patch modules" helper
293EOF 432 write_shellscript SP-patch-postinstall <<'end_of_patch_postinstall'
294 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 433#CAT patch-postinstall.sh
434end_of_patch_postinstall
295 435
436 # immediately use it
437 "$PERL_PREFIX/bin/SP-patch-postinstall"
438
296 # trick CPAN into avoiding ~/.cpan completely 439 # help to trick CPAN into avoiding ~/.cpan completely
297 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 440 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
298 441
442 # we call cpan with -MCPAN::MyConfig in this script, which
443 # is strictly unnecessary as we have to patch CPAN anyway,
444 # so consider it "for good measure".
299 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 445 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
300 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 446 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
447 CPAN::Shell->o (conf => pushy_https => "0");
301 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 448 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
302 CPAN::Shell->o (conf => q<init>); 449 CPAN::Shell->o (conf => q<init>);
303 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 450 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
304 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 451 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
305 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 452 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
306 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 453 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
307 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 454 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
455 CPAN::Shell->o (conf => q<makepl_arg>, "MAP_TARGET=perl");
456 CPAN::Shell->o (conf => q<make>, "'"$PERL_PREFIX"'/bin/SP-make-make");
308 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 457 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
309 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 458 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
310 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 459 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<yes>);
460 CPAN::Shell->o (conf => q<recommends_policy>, q<0>);
461 CPAN::Shell->o (conf => q<suggests_policy>, q<0>);
462 CPAN::Shell->o (conf => q<prefer_installer>, q<EUMM>);
311 CPAN::Shell->o (conf => q<commit>); 463 CPAN::Shell->o (conf => q<commit>);
312 ' || fatal "error while initialising CPAN" 464 ' || fatal "error while initialising CPAN"
313 465
466 postcpanconfig
467
314 touch "$PERL_PREFIX/staticstamp.install" 468 : > "$PERL_PREFIX/staticstamp.install"
315 fi 469 fi
316 470
471 _postinstall
472) || exit
473}
474
475import() {
476(
477 IMPORT="$1"
478
479 rcd "$STATICPERL"
480
317 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then 481 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
318 NOCHECK_INSTALL=+ 482 verblock <<EOF
319 instcpan $STATICPERL_MODULES 483import perl from $IMPORT to $STATICPERL
320 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 484EOF
321 485
322 postinstall || fatal "postinstall hook failed" 486 rm -rf bin cpan lib patched perl src
487 mkdir -m 755 perl perl/bin
488 ln -s perl/bin/ bin
489 ln -s "$IMPORT" perl/bin/
323 490
491 echo "$IMPORT" > "$PERL_PREFIX/.import"
492
324 touch "$PERL_PREFIX/staticstamp.postinstall" 493 : > "$PERL_PREFIX/staticstamp.install"
325 fi 494 fi
495
496 _postinstall
497) || exit
326} 498}
327 499
328############################################################################# 500#############################################################################
329# install a module from CPAN 501# install a module from CPAN
330 502
331instcpan() { 503instcpan() {
332 [ $NOCHECK_INSTALL ] || install 504 [ $NOCHECK_INSTALL ] || install
333 505
334 verblock <<EOF 506 verblock <<EOF
335installing modules from CPAN 507installing modules from CPAN
336$@ 508$*
337EOF 509EOF
338 510
339 for mod in "$@"; do 511 MYCONFIG=
340 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 512 [ -e "$PERL_PREFIX/.import" ] || MYCONFIG=-MCPAN::MyConfig
341 || fatal "$mod: unable to install from CPAN" 513
342 done 514 "$PERL_PREFIX"/bin/perl $MYCONFIG -MCPAN -e 'notest (install => $_) for @ARGV' -- "$@" | tee "$STATICPERL/instcpan.log"
515
516 if grep -q " -- NOT OK\$" "$STATICPERL/instcpan.log"; then
517 fatal "failure while installing modules from CPAN ($*)"
518 fi
343 rm -rf "$STATICPERL/build" 519 rm -f "$STATICPERL/instcpan.log"
344} 520}
345 521
346############################################################################# 522#############################################################################
347# install a module from unpacked sources 523# install a module from unpacked sources
348 524
349instsrc() { 525instsrc() {
350 [ $NOCHECK_INSTALL ] || install 526 [ $NOCHECK_INSTALL ] || install
351 527
352 verblock <<EOF 528 verblock <<EOF
353installing modules from source 529installing modules from source
354$@ 530$*
355EOF 531EOF
356 532
357 for mod in "$@"; do 533 for mod in "$@"; do
358 echo 534 echo
359 echo $mod 535 echo $mod
360 ( 536 (
361 rcd $mod 537 rcd $mod
362 make -f Makefile.aperl map_clean >/dev/null 2>&1 538 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
363 make distclean >/dev/null 2>&1 539 "$MAKE" distclean >/dev/null 2>&1
364 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 540 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
365 make || fatal "$mod: error building module" 541 "$MAKE" || fatal "$mod: error building module"
366 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 542 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
367 make distclean >/dev/null 2>&1 543 "$MAKE" distclean >/dev/null 2>&1
368 exit 0 544 exit 0
369 ) || exit $? 545 ) || exit $?
370 done 546 done
371} 547}
372 548
373############################################################################# 549#############################################################################
374# main 550# main
375 551
376podusage() { 552podusage() {
377 echo 553 echo
554
378 if [ -e "$PERL_PREFIX/bin/perl" ]; then 555 if [ -e "$PERL_PREFIX/bin/perl" ]; then
379 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 556 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
380 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 557 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
381 2>/dev/null && exit 558 2>/dev/null && exit
382 fi 559 fi
560
383 # try whatever perl we can find 561 # try whatever perl we can find
384 perl -MPod::Usage -e \ 562 perl -MPod::Usage -e \
385 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 563 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
386 2>/dev/null && exit 564 2>/dev/null && exit
387 565
388 fatal "displaying documentation requires a working perl - try '$0 install' first" 566 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
389} 567}
390 568
391usage() { 569usage() {
392 podusage 0 570 podusage 0
393} 571}
395catmkbundle() { 573catmkbundle() {
396 { 574 {
397 read dummy 575 read dummy
398 echo "#!$PERL_PREFIX/bin/perl" 576 echo "#!$PERL_PREFIX/bin/perl"
399 cat 577 cat
400 } <<'MKBUNDLE' 578 } <<'end_of_mkbundle'
401#CAT mkbundle 579#CAT mkbundle
402MKBUNDLE 580end_of_mkbundle
403} 581}
404 582
405bundle() { 583bundle() {
584 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
406 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 585 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
407 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 586 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
408 CACHE="$STATICPERL/cache" 587 CACHE="$STATICPERL/cache"
409 mkdir -p "$CACHE" 588 mkdir -p "$CACHE"
410 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 589 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
418 command="${1#--}"; shift 597 command="${1#--}"; shift
419 case "$command" in 598 case "$command" in
420 version ) 599 version )
421 echo "staticperl version $VERSION" 600 echo "staticperl version $VERSION"
422 ;; 601 ;;
423 fetch | configure | build | install | clean | distclean) 602 fetch | configure | build | install | clean | realclean | distclean )
424 ( "$command" ) 603 ( "$command" ) || exit
604 ;;
605 import )
606 ( import "$1" ) || exit
607 shift
425 ;; 608 ;;
426 instsrc ) 609 instsrc )
427 ( instsrc "$@" ) 610 ( instsrc "$@" ) || exit
428 exit 611 exit
429 ;; 612 ;;
430 instcpan ) 613 instcpan )
431 ( instcpan "$@" ) 614 ( instcpan "$@" ) || exit
432 exit 615 exit
433 ;; 616 ;;
617 perl )
618 ( install ) || exit
619 exec "$PERL_PREFIX/bin/perl" "$@"
620 exit
621 ;;
434 cpan ) 622 cpan )
435 ( install ) 623 ( install ) || exit
624 PERL="$PERL_PREFIX/bin/perl"
625 export PERL
436 "$PERL_PREFIX/bin/cpan" "$@" 626 exec "$PERL_PREFIX/bin/cpan" "$@"
437 exit 627 exit
438 ;; 628 ;;
439 mkbundle ) 629 mkbundle )
440 ( install ) 630 ( install ) || exit
441 bundle "$@" 631 bundle "$@"
442 exit 632 exit
443 ;; 633 ;;
444 mkperl ) 634 mkperl )
445 ( install ) 635 ( install ) || exit
446 bundle --perl "$@" 636 bundle --perl "$@"
447 exit 637 exit
448 ;; 638 ;;
449 mkapp ) 639 mkapp )
450 ( install ) 640 ( install ) || exit
451 bundle --app "$@" 641 bundle --app "$@"
452 exit 642 exit
453 ;; 643 ;;
454 help ) 644 help )
455 podusage 2 645 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines